<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AlertCLinearByCode StructType
 * @subpackage Structs
 */
class AlertCLinearByCode extends AlertCLinear
{
    /**
     * The alertCDirection
     * @var \StructType\AlertCDirection
     */
    public $alertCDirection;
    /**
     * The locationCodeForLinearLocation
     * @var \StructType\AlertCLocation
     */
    public $locationCodeForLinearLocation;
    /**
     * The alertCLinearByCodeExtension
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ExtensionType
     */
    public $alertCLinearByCodeExtension;
    /**
     * Constructor method for AlertCLinearByCode
     * @uses AlertCLinearByCode::setAlertCDirection()
     * @uses AlertCLinearByCode::setLocationCodeForLinearLocation()
     * @uses AlertCLinearByCode::setAlertCLinearByCodeExtension()
     * @param \StructType\AlertCDirection $alertCDirection
     * @param \StructType\AlertCLocation $locationCodeForLinearLocation
     * @param \StructType\ExtensionType $alertCLinearByCodeExtension
     */
    public function __construct(\StructType\AlertCDirection $alertCDirection = null, \StructType\AlertCLocation $locationCodeForLinearLocation = null, \StructType\ExtensionType $alertCLinearByCodeExtension = null)
    {
        $this
            ->setAlertCDirection($alertCDirection)
            ->setLocationCodeForLinearLocation($locationCodeForLinearLocation)
            ->setAlertCLinearByCodeExtension($alertCLinearByCodeExtension);
    }
    /**
     * Get alertCDirection value
     * @return \StructType\AlertCDirection|null
     */
    public function getAlertCDirection()
    {
        return $this->alertCDirection;
    }
    /**
     * Set alertCDirection value
     * @param \StructType\AlertCDirection $alertCDirection
     * @return \StructType\AlertCLinearByCode
     */
    public function setAlertCDirection(\StructType\AlertCDirection $alertCDirection = null)
    {
        $this->alertCDirection = $alertCDirection;
        return $this;
    }
    /**
     * Get locationCodeForLinearLocation value
     * @return \StructType\AlertCLocation|null
     */
    public function getLocationCodeForLinearLocation()
    {
        return $this->locationCodeForLinearLocation;
    }
    /**
     * Set locationCodeForLinearLocation value
     * @param \StructType\AlertCLocation $locationCodeForLinearLocation
     * @return \StructType\AlertCLinearByCode
     */
    public function setLocationCodeForLinearLocation(\StructType\AlertCLocation $locationCodeForLinearLocation = null)
    {
        $this->locationCodeForLinearLocation = $locationCodeForLinearLocation;
        return $this;
    }
    /**
     * Get alertCLinearByCodeExtension value
     * @return \StructType\ExtensionType|null
     */
    public function getAlertCLinearByCodeExtension()
    {
        return $this->alertCLinearByCodeExtension;
    }
    /**
     * Set alertCLinearByCodeExtension value
     * @param \StructType\ExtensionType $alertCLinearByCodeExtension
     * @return \StructType\AlertCLinearByCode
     */
    public function setAlertCLinearByCodeExtension(\StructType\ExtensionType $alertCLinearByCodeExtension = null)
    {
        $this->alertCLinearByCodeExtension = $alertCLinearByCodeExtension;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AlertCLinearByCode
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
